/*
//	Mag.cc -- mag $@%U%)!<%^%C%H2hA|$r07$&(J
//
//		created    in 3/2/1993
//		revised    in 2/12/1994
*/

#include	<stdio.h>
#include	<stdlib.h>
#include	<string.h>
#include	<ctype.h>
#include	"defs.h"
#include	"Mag.h"

struct {
	char	Head;
	char	Machine;
	char	MachineDependence;
	char	ScreenMode;
	int16	Left;
	int16	Top;
	int16	Right;
	int16	Bottom;
	uint32	FlagAOffset;
	uint32	FlagBOffset;
	uint32	FlagBSize;
	uint32	PixelOffset;
	uint32	PixelSize;
}	MagHeader;

static int 	DoubleLine;
static char	*FlagA, *FlagB, *Flag;
static int	OriginalDX[] = { 0, 1, 2, 4, 0, 1, 0, 1, 2, 0, 1, 2, 0, 1, 2, 0 };
static int	OriginalDY[] = { 0, 0, 0, 0, 1, 1, 2, 2, 2, 4, 4, 4, 8, 8, 8, 16 };
static int	Index[]= { 1, 4, 5, 6, 7, 9, 10, 2, 8, 11, 12, 13, 14, 3, 15, 0 };
static char	*FlagBuffer;
static int	MaxColor;

void	MagDecode( char *FlagA, char *FlagB )
{
	int	D[16];
	int	Width8, x, xx, y, gy;
	unsigned short	*w;
	unsigned char	a;
	char	*f;

	for ( x = 0; x < 16; x++ ) {
		D[x] = OriginalDY[x] * Width + OriginalDX[x] * 4;
	}

	Width8 = (Width + 7) >> 3;
	for ( x = 0; x < Width; x++ )
		FlagBuffer[x] = 0;
	xx = 0;
	gy = 0;

	y= Height;
	while( --y >= 0 ) {
		w= Screen + gy;
		f= FlagBuffer;
		x= Width8;
		while( --x >= 0 ) {
			unsigned short	*r;
			unsigned char	c0, c1;
			char	Flag;

			if ( --xx < 0 ) {
				xx = 7;
				a = (unsigned char)(*FlagA++);
			}
			else
				a *= 2;

			if ( a & 0x80 )
				*f ^= *FlagB++;

			Flag = (*f >> 4) & 0x0f;
			if ( Flag == 0 ) {
				c0 = fgetc (fp);
				c1 = fgetc (fp);
				*w++ = (c0 >> 4) & 0x0f;
				*w++ = c0 & 0x0f;
				*w++ = (c1 >> 4) & 0x0f;
				*w++ = c1 & 0x0f;
			}
			else {
				r= w - D[Flag];
				*w++ = *r++;
				*w++ = *r++;
				*w++ = *r++;
				*w++ = *r;
			}
			Flag = *f++ & 0x0f;
			if ( Flag == 0 ) {
				c0 = fgetc (fp);
				c1 = fgetc (fp);
				*w++ = (c0 >> 4) & 0x0f;
				*w++ = c0 & 0x0f;
				*w++ = (c1 >> 4) & 0x0f;
				*w++ = c1 & 0x0f;
			}
			else {
				r= w - D[Flag];
				*w++ = *r++;
				*w++ = *r++;
				*w++ = *r++;
				*w++ = *r;
			}
		}
		gy += Width;
	}
}

void	MagDecode256( char *FlagA, char *FlagB )
{
    int	D[16];
	int	Width8, x, xx, y, gy;
	unsigned short	*w;
	unsigned char	a;
	char	*f;

	for ( x = 0; x < 16; x++ ) {
		D[x] = OriginalDY[x] * Width + OriginalDX[x] * 2;
	}

	Width8 = (Width + 3) >> 2;
	for (x = 0; x < Width; x++)
		FlagBuffer[x] = 0;
	xx = 0;
	gy = 0;

	y= Height;
	while( --y >= 0 ){
		w= Screen + gy;
		f= FlagBuffer;
		x= Width8;
		while( --x >= 0 ){
			unsigned short	*r;
			unsigned char	c0, c1;
			char	Flag;

			if( --xx < 0 ){
				xx = 7;
				a = (unsigned char)(*FlagA++);
			}
			else
				a *= 2;

			if( a & 0x80 )
				*f ^= *FlagB++;

			Flag = (*f >> 4) & 0x0f;
			if ( Flag == 0 ) {
				c0 = fgetc (fp);
				c1 = fgetc (fp);
				*w++ = c0 & 0xff;
				*w++ = c1 & 0xff;
			}
			else {
				r = w - D[Flag];
				*w++ = *r++;
				*w++ = *r;
			}
			Flag = *f++ & 0x0f;
			if ( Flag == 0 ) {
				c0 = fgetc (fp);
				c1 = fgetc (fp);
				*w++ = c0 & 0xff;
				*w++ = c1 & 0xff;
			}
			else {
				r = w - D[Flag];
				*w++ = *r++;
				*w++ = *r;
			}
		}
		gy += Width;
	}
}

void    ReadMagHeader()
{
    int 	i;

    MagHeader.Head = fgetc (fp);
    MagHeader.Machine = fgetc (fp);
    MagHeader.MachineDependence = fgetc (fp);
    MagHeader.ScreenMode = fgetc (fp);
    MagHeader.Left = ReadWord();
    MagHeader.Top = ReadWord();
    MagHeader.Right = ReadWord();
    MagHeader.Bottom = ReadWord();
    MagHeader.FlagAOffset = ReadDWord();
    MagHeader.FlagBOffset = ReadDWord();
    MagHeader.FlagBSize = ReadDWord();
    MagHeader.PixelOffset = ReadDWord();
    MagHeader.PixelSize = ReadDWord();
    if ( MagHeader.ScreenMode & 1 )
	DoubleLine = 1;
    else
	DoubleLine = 0;
    if ( MagHeader.ScreenMode & 0x80 ) {
	MaxColor = 256;
	DoubleLine = 0;
    }
    else
	MaxColor = 16;
    for ( i = 0; i < MaxColor; i++ ) {
        Green[i] = fgetc (fp);
        Red[i] = fgetc (fp);
        Blue[i] = fgetc (fp);
	}

    Width = (MagHeader.Right & 0xff8) - (MagHeader.Left & 0xff8) + 8;
    Height = MagHeader.Bottom - MagHeader.Top + 1;
    if ( DoubleLine )
	Height = Height * 2;
    AllocateScreen();
    if ( (int)(FlagA = (char*)MALLOC (MagHeader.FlagBOffset - MagHeader.FlagAOffset + 256)) < 0 )
	error ("%s: Insufficient memory");
    if ( (int)(FlagB = (char*)MALLOC(MagHeader.PixelOffset - MagHeader.FlagBOffset + 256)) < 0 )
	error ("%s: Insufficient memory");
    fread( FlagA, 1, MagHeader.FlagBOffset - MagHeader.FlagAOffset, fp );
    fread( FlagB, 1, MagHeader.PixelOffset - MagHeader.FlagBOffset, fp );
}

int16	ReadWord()
{
    int 	c0, c1;

    c0 = fgetc (fp);
    c1 = fgetc (fp);
    return (int16)(c0 | (c1 << 8));
}

uint32	ReadDWord()
{
    uint32 	c0, c1, c2, c3;

    c0 = fgetc (fp);
    c1 = fgetc (fp);
    c2 = fgetc (fp);
    c3 = fgetc (fp);
    return (uint32)(c0 | (c1 << 8) | (c2 << 16) | (c3 << 24));
}

void	MagLoad()
{
    int 	c, x, y, i, j;

    if ( fp == NULL && (fp = fopen( File, "rb" )) == NULL )
	error ("%s: No such file");
    if ( fgetc (fp) != 'M' || fgetc (fp) != 'A'
	 || fgetc (fp) != 'K' || fgetc (fp) != 'I'
	 || fgetc (fp) != '0' || fgetc (fp) != '2'
	 || fgetc (fp) != ' ' || fgetc (fp) != ' ' )
	error ("%s: Is not mag format");
    for ( ; (c = fgetc (fp)) != 0x1a && c != EOF; );
    ReadMagHeader();
    if ( (int)(FlagBuffer = (char*)MALLOC (Width + 16)) < 0 )
	error ("%s: Insufficient memory");
    if ( MaxColor == 16 )
	MagDecode( FlagA, FlagB );
    else
	MagDecode256( FlagA, FlagB );
    if ( fp != stdin )
	fclose(fp);
    MFREE (FlagA);
    MFREE (FlagB);
    MFREE (FlagBuffer);
    MaxColorGuaranteed = MaxColor;
    if ( DoubleLine ) {
	for ( y = Height / 2 - 1; y >= 0; y-- ) {
	    i = y * 2 * Width;
	    j = y * Width;
	    for ( x = Width - 1; x >= 0; x-- ) {
		Screen[x + i] = Screen[x + j];
		Screen[x + i + Width] = Screen[x + j];
	    }
	}
    }
}

void	MagSave()
{
	if ( fp == NULL && (fp = fopen( File, "wb" )) == NULL )
			error ("%s: Cannot create");

	if ( MaxColorGuaranteed <= 16 ) {
		Mag16Save();
	}else {
		Mag256Save();
	}

	MFREE (Flag);
	MFREE (FlagA);
	MFREE (FlagB);
	MFREE (FlagBuffer);

	if ( fp != stdout )
		fclose (fp);
}

void
Mag16Save()
{
	int	i, j, FlagWidth, x, y;
	int	DX[16], DY[16], D[16];
	int	FlagASize, FlagBSize, PixelSize;

	for ( i = 0; i < 16; i++ ) {
		DX[i] = OriginalDX[i] * 4;
		DY[i] = OriginalDY[i];
		D[i] = DY[i] * Width + DX[i];
	}
	FlagWidth = (Width + 7) / 8;

	if ( (int)(Flag = (char*)MALLOC (FlagWidth * Height + 32)) < 0 )
		error ("%s: Insufficient memory");
	PixelSize = 0;
	for ( y = 0; y < Height; y++ ) {
		unsigned char	*r = (unsigned char*)Screen + y * Width;
		unsigned char	*f = Flag + y * FlagWidth;
		for ( x = 0; x < Width; ) {
			int	*curi = Index;
			unsigned char	*c;

			do{
				if ( x - DX[*curi] >= 0 && y - DY[*curi] >= 0 ) {
					c= r - D[*curi];
					if ( *r == *c
							&& *(r + 1) == *(c + 1)
							&& *(r + 2) == *(c + 2)
							&& *(r + 3) == *(c + 3) ) {
						*f = *curi << 4;
						break;
					}
				}
			} while( *++curi );
			if( !*curi ){
				*f = 0;
				PixelSize += 2;
			}
			x += 4;
			r += 4;
			curi = Index;
			do{
				if ( x - DX[*curi] >= 0 && y - DY[*curi] >= 0 ) {
					c= r - D[*curi];
					if ( *r == *c
							&& *(r + 1) == *(c + 1)
							&& *(r + 2) == *(c + 2)
							&& *(r + 3) == *(c + 3) ) {
						*f |= *curi;
						break;
					}
				}
			} while( *++curi );
			if( !*curi ){
				PixelSize += 2;
			}
			x += 4;
			r += 4;
			f++;
		}
	}

	for ( y = Height - 1; y >= 1; y-- ) {
		char	*n, *p;

		n= Flag + y * FlagWidth;
		p= n - FlagWidth;
		for ( x = 0; x < FlagWidth; x++ ) {
			*n++ ^= *p++;
		}
	}
	if ( (int)(FlagA = (char*)MALLOC (FlagWidth * Height + 128)) < 0 )
		error ("%s: Insufficient memory");
	FlagASize = FlagBSize = 0;
	x = 8;
	y = 0;
	for ( i = 0; i < Height * FlagWidth; i++ ) {
		if( --x < 0 ){
			x = 7;
			FlagA[(FlagASize - 1) >> 3] = y;
			y = 0;
		}
		else {
			y *= 2;
		}

		if ( Flag[i] != 0 ) {
			y += 1;
			FlagBSize++;
		}
		FlagASize++;
	}
	FlagA[(FlagASize - 1) >> 3] = y << x;
	FlagASize = (FlagASize + 7) / 8;
	if ( FlagASize & 1 )
		FlagASize++;
	if ( FlagBSize & 1 )
		FlagBSize++;
	if ( (int)(FlagB = (char*)MALLOC (FlagBSize + 16)) < 0 )
		error ("%s: Insufficient memory");
	fputs( "MAKI02  UNIX012345678901234567\x1a", fp );
	fputc( 0, fp ); fputc( 0x9a, fp ); fputc( 0xab, fp ); fputc( 0, fp );
	WriteWord (0);
	WriteWord (0);
	WriteWord (FlagWidth * 8 - 1);
	WriteWord (Height - 1);
	WriteDWord (32 + 48);
	WriteDWord (32 + 48 + FlagASize);
	WriteDWord (FlagBSize);
	WriteDWord (32 + 48 + FlagASize + FlagBSize);
	WriteDWord (PixelSize);
	for ( i = 0; i < 16; i++ ) {
		fputc( Green[i], fp );
		fputc( Red[i], fp );
		fputc( Blue[i], fp );
	}
	fwrite( FlagA, 1, FlagASize, fp );
	i = 0;
	j = 0;
	for ( y = 0; y < Height; y++ ) {
		for ( x = 0; x < FlagWidth; x++ ) {
			if ( Flag[i] != 0 )
				FlagB[j++] = Flag[i];
			i++;
		}
	}
	fwrite( FlagB, 1, FlagBSize, fp );
	if ( (int)(FlagBuffer = (char*)MALLOC (Width + 16)) < 0 )
		error ("%s: Insufficient memory");
	WriteMagImage( FlagA, FlagB );
}

void
Mag256Save()
{
	int	i, j, FlagWidth, x, y;
	int	DX[16], DY[16], D[16];
	int	FlagASize, FlagBSize, PixelSize;

	for ( i = 0; i < 16; i++ ) {
		DX[i] = OriginalDX[i] * 2;
		DY[i] = OriginalDY[i];
		D[i] = DY[i] * Width + DX[i];
	}
	FlagWidth = (Width + 3) / 4;
	if ( FlagWidth & 1 )
	    FlagWidth++;

	if ( (int)(Flag = (char*)MALLOC (FlagWidth * Height + 32)) < 0 )
		error ("%s: Insufficient memory");
	PixelSize = 0;
	for ( y = 0; y < Height; y++ ) {
		unsigned char	*r = (unsigned char*)Screen + y * Width;
		unsigned char	*f = Flag + y * FlagWidth;
		for ( x = 0; x < Width; ) {
			int	*curi= Index;
			unsigned char	*c;

			do{
				if ( x - DX[*curi] >= 0 && y - DY[*curi] >= 0 ) {
					c= r - D[*curi];
					if ( *r == *c && *(r + 1) == *(c + 1) ) {
						*f = *curi << 4;
						break;
					}
				}
			} while( *++curi );
			if( !*curi ){
				*f = 0;
				PixelSize += 2;
			}
			x += 2;
			r += 2;

			curi= Index;
			do{
				if ( x - DX[*curi] >= 0 && y - DY[*curi] >= 0 ) {
					c= r - D[*curi];
					if ( *r == *c && *(r + 1) == *(c + 1) ) {
						*f |= *curi;
						break;
					}
				}
			} while( *++curi );
			if( !*curi ){
				PixelSize += 2;
			}

			x += 2;
			r += 2;
			f++;
	    }
	}
	for ( y = Height - 1; y >= 1; y-- ) {
		char	*n, *p;

		n= Flag + y * FlagWidth;
		p= n - FlagWidth;
		for ( x = 0; x < FlagWidth; x++ ) {
			*n++ ^= *p++;
		}
	}
	if ( (int)(FlagA = (char*)MALLOC (FlagWidth * Height + 128)) < 0 )
	    error ("%s: Insufficient memory");
	FlagASize = FlagBSize = 0;
	x = 8;
	y = 0;
	for ( i = 0; i < Height * FlagWidth; i++ ) {
		if( --x < 0 ){
			x = 7;
			FlagA[(FlagASize - 1) >> 3] = y;
			y = 0;
		}
		else {
			y *= 2;
		}

		if ( Flag[i] != 0 ) {
			y += 1;
			FlagBSize++;
		}
		FlagASize++;
	}
	FlagA[(FlagASize - 1) >> 3] = y << x;
	FlagASize = (FlagASize + 7) / 8;
	if ( FlagASize & 1 )
	    FlagASize++;
	if ( FlagBSize & 1 )
	    FlagBSize++;
	if ( (int)(FlagB = (char*)MALLOC (FlagBSize + 16)) < 0 )
	    error ("%s: Insufficient memory");
	fputs( "MAKI02  UNIX012345678901234567\x1a", fp );
	fputc( 0, fp ); fputc( 0x9a, fp ); fputc( 0xab, fp ); fputc( 0x80, fp );
	WriteWord (0);
	WriteWord (0);
	WriteWord (FlagWidth * 4 - 1);
	WriteWord (Height - 1);
	WriteDWord (32 + 768);
	WriteDWord (32 + 768 + FlagASize);
	WriteDWord (FlagBSize);
	WriteDWord (32 + 768 + FlagASize + FlagBSize);
	WriteDWord (PixelSize);
	for ( i = 0; i < 256; i++ ) {
	    fputc( Green[i], fp );
	    fputc( Red[i], fp );
	    fputc( Blue[i], fp );
	}
	fwrite( FlagA, 1, FlagASize, fp );
	i = 0;
	j = 0;
	for ( y = 0; y < Height; y++ ) {
	    for ( x = 0; x < FlagWidth; x++ ) {
		if ( Flag[i] != 0 )
		    FlagB[j++] = Flag[i];
		i++;
	    }
	}
	fwrite( FlagB, 1, FlagBSize, fp );
	if ( (int)(FlagBuffer = (char*)MALLOC (Width + 16)) < 0 )
	    error ("%s: Insufficient memory");
	WriteMagImage256( FlagA, FlagB );
}

void	WriteWord( int16 c )
{
    fputc( c & 0xff, fp );
    fputc( (c >> 8) & 0xff, fp );
}

void	WriteDWord( uint32 c )
{
    fputc( c & 0xff, fp );
    fputc( (c >> 8) & 0xff, fp );
    fputc( (c >> 16) & 0xff, fp );
    fputc( (c >> 24) & 0xff, fp );
}

void    WriteMagImage( char *FlagA, char *FlagB )
{
	int	Width8, x, xx, y, gy;
	unsigned char	*r;
	unsigned char	a;
	char	*f;

	Width8 = (Width + 7) >> 3;
	for (x = 0; x < Width; x++)
		FlagBuffer[x] = 0;
	xx = 0;
	gy = 0;

	y= Height;
	while( --y >= 0 ){
		r= (unsigned char*)Screen + gy;
		f= FlagBuffer;
		x= Width8;
		while( --x >= 0 ){
			unsigned char	c;
			char	Flag;

			if( --xx < 0 ){
				xx= 7;
				a = (unsigned char)(*FlagA++);
			}
			else
				a *= 2;

			if( a & 0x80 )
				*f ^= *FlagB++;

			Flag = (*f >> 4) & 0x0f;
			if ( Flag == 0 ) {
				c= *r++ << 4;
				c|= *r++;
				fputc( c, fp );
				c= *r++ << 4;
				c|= *r++;
				fputc( c, fp );
			}
			else
				r+= 4;
			Flag = *f++ & 0x0f;
			if ( Flag == 0 ) {
				c= *r++ << 4;
				c|= *r++;
				fputc( c, fp );
				c= *r++ << 4;
				c|= *r++;
				fputc( c, fp );
			}
			else
				r+= 4;
		}
		gy += Width;
	}
}

void	WriteMagImage256( char *FlagA, char *FlagB )
{
	int 	Width8, x, xx, y, gy;
	unsigned char	*r;
	unsigned char	a;
	char	*f;

	Width8 = (Width + 3) / 4;
	if ( Width8 & 1 )
		Width8++;
	for (x = 0; x < Width; x++)
		FlagBuffer[x] = 0;
	xx = 0;
	gy = 0;

	y= Height;
	while( --y >= 0 ) {
		r= (unsigned char*)Screen + gy;
		f= FlagBuffer;
		x= Width8;
		while( --x >= 0 ){
		char	Flag;

			if( --xx < 0 ){
				xx= 7;
				a = (unsigned char)(*FlagA++);
			}
			else
				a *= 2;

			if( a & 0x80 )
				*f ^= *FlagB++;

			Flag = (*f >> 4) & 0x0f;
			if ( Flag == 0 ) {
				fputc( *r++, fp );
				fputc( *r++, fp );
			}
			else
				r+= 2;
			Flag = *f++ & 0x0f;
			if ( Flag == 0 ) {
				fputc( *r++, fp );
				fputc( *r++, fp );
			}
			else
				r+= 2;
		}
		gy += Width;
	}
}
